"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Modals = void 0;
const react_1 = __importStar(require("react"));
const Cross_1 = require("@procyon/components/Icons/Cross");
const utils_1 = require("@procyon/utils");
const hooks_1 = require("../hooks");
const Modals = () => {
    const { modals, opened, closeModal } = (0, hooks_1.useModal)();
    const handleCloseModal = (modalId) => {
        var _a, _b, _c;
        (_c = (_b = (_a = modals[modalId]) === null || _a === void 0 ? void 0 : _a.props) === null || _b === void 0 ? void 0 : _b.onClose) === null || _c === void 0 ? void 0 : _c.call(_b);
        closeModal(modalId);
    };
    const handleKeyUp = (e) => {
        if (e.key === 'Escape') {
            const modalId = opened.at(-1);
            if (modalId !== undefined) {
                handleCloseModal(modalId);
            }
        }
    };
    (0, react_1.useEffect)(() => {
        window.addEventListener('keydown', handleKeyUp);
        return () => {
            window.removeEventListener('keydown', handleKeyUp);
        };
    }, [handleKeyUp]);
    if ((0, utils_1.isNilOrEmpty)(opened)) {
        return null;
    }
    return (react_1.default.createElement(react_1.default.Fragment, null, opened.map((modalId) => {
        const { id, style, title, Component, props } = modals[modalId];
        return (react_1.default.createElement("div", { key: id, className: "modal-wrapper bg-black bg-opacity-70" },
            react_1.default.createElement("div", { className: "modal-container", style: Object.assign({ width: style === null || style === void 0 ? void 0 : style.width }, ((style === null || style === void 0 ? void 0 : style.overrideMaxWidth) ? { maxWidth: 'initial' } : {})) },
                react_1.default.createElement("div", { className: "modal-title" },
                    title,
                    react_1.default.createElement("div", { className: "modal-cross", onClick: () => handleCloseModal(id) },
                        react_1.default.createElement(Cross_1.CrossIcon, null))),
                react_1.default.createElement("div", { className: "modal-body", onClick: (e) => e.stopPropagation() },
                    react_1.default.createElement(Component, Object.assign({}, props))))));
    })));
};
exports.Modals = Modals;
exports.default = exports.Modals;
